/*  Call a command for every file (not directory)  */
usage.0=12
usage.1 =' Usage: foreach [-?rlvVdDRx] <filespec> <command>'
usage.2 ="         -? : this help"
usage.3 ='         -r : search subdirectories'
usage.4 ='         -l : list found files'
usage.5 ='         -v : type command before executing'
usage.6 ='         -V : type command without executing'
usage.7 ='         -d : include directories'
usage.8 ='         -D : directories only'
usage.9 ='         -R : use relative paths when possible'
usage.10="         -x : execute REXX command ('file' variable gives filename)"
usage.11='  {} in command will be replaced with filename'
usage.12='  Use @ as empty command'

/* history:
  2001-06-12
    added options -x and -?
    command line parser rewritten a little

  2000-09-19
    added options -VdD
    added option -R
    "no files found" is now displayed only with -l option

  2000-04-22/24
    www.os2.spb.ru & Andrey Zakharchenko
*/

cmdline = arg(1)
treeflag1 = "F"
treeflag2 = ""
list = 0
verbose = 0
verbonly = 0
rel = 0
rexxmode = 0
helpmode = 0

if left(cmdline, 1) = '-' then
  do while left(cmdline,1)\=' '
  flag = left(cmdline,1)
  cmdline = substr(cmdline,2)
  select
    when flag='-' then nop
    when flag='r' then treeflag2 = "S"
    when flag='d' then treeflag1 = "B"
    when flag='D' then treeflag1 = "D"
    when flag='l' then list = 1
    when flag='v' then verbose = 1
    when flag='V' then verbonly = 1
    when flag='R' then rel = 1
    when flag='x' then rexxmode = 1
    when flag='?' then helpmode = 1
  otherwise
    helpmode = 1
  end
end

cmdline=strip(cmdline,'l')
parse var cmdline mask cmdline
cmdline=strip(cmdline,'l')

if cmdline='' then helpmode = 1

if helpmode\=0 then do
  do i=1 to usage.0
    say usage.i
  end
  return
end

if verbonly then verbose=1

treeflag=treeflag1||treeflag2||'O'

call RxFuncAdd 'SysFileTree', 'RexxUtil', 'SysFileTree'

rc = SysFileTree(mask, filelist, treeflag)

if rc > '0' then do
  say "Error: not enough memory."
  exit
end

if filelist.0 = '0' then do
  if list>0 then say "No files matching "mask
  exit
end

cwd = directory()||'\'

if rel then do i=1 to filelist.0
  if abbrev(filelist.i,cwd) then filelist.i=substr(filelist.i,length(cwd)+1)
end

if list then do
  say filelist.0" files found:"
  do i = 1 to filelist.0
    say filelist.i
  end
end

do i = 1 to filelist.0
  commandline = cmdline
  k = pos('{}', commandline);
  do while k > '0'
    commandline = left(commandline, k-1)''filelist.i''substr(commandline, k+2)
    k = pos('{}', commandline);
  end;
  if verbose then say commandline
  if \verbonly then do
    if rexxmode then do
      file=filelist.i
      interpret commandline
    end
    else '@'commandline
  end
end

exit

